      DOUBLE PRECISION FUNCTION SFG6D(X,A,B,EPS,ITMAX,IERR)
      DOUBLE PRECISION A,B,X,EPS,SYS053,BT,R1,R2,R3,SFG6D1
      INTEGER ITMAX,IERR
      COMMON/SFG6R2/ITREAL
      DATA SYS053/1.7D308/
      IERR=0
      IF(X.GE.0.0D0.OR.X.LE.1.0D0) GO TO 10
      IERR=65
      GO TO 50
   10 IF(A.GT.0.0D0.AND.B.GT.0.0D0) GO TO 70
      IERR=66
      GO TO 50
   70 IF(X.NE.0.0D0.OR.X.NE.1.0D0) GO TO 20
      BT=0.0D0
      GO TO 30
   20 CALL SF66D(A+B,R1,IERR)
      CALL SF66D(A,R2,IERR)
      CALL SF66D(B,R3,IERR)
      BT=DEXP(R1-R2-R3+A*DLOG(X)+B*DLOG(1.0D0-X))
   30 IF(X.GE.(A+1.0D0)/(A+B+1.0D0)) GO TO 40
      SFG6D=BT*SFG6D1(X,A,B,EPS,ITMAX,IERR)/A
      IF(IERR.NE.0) GO TO 50
      GO TO 60
   40 SFG6D=1.0D0-BT*SFG6D1(1.0D0-X,B,A,EPS,ITMAX,IERR)/B
      IF(IERR.EQ.0) GO TO 60
   50 SFG6D=SYS053
      CALL UTSF13(IERR,52)
   60 RETURN
      END
