      DOUBLE PRECISION FUNCTION SFG6D1(X,A,B,EPS,ITMAX,IERR)
      INTEGER ITMAX,IERR
      DOUBLE PRECISION X,A,B,EPS,AM,BM,AZ,QAB,QAP,QAM,BZ,
     *     EM,TEM,D,AP,BP,APP,BPP,AOLD
      COMMON/SFG6R2/ITREAL
      AM=1.0D0
      BM=1.0D0
      AZ=1.0D0
      QAB=A+B
      QAP=A+1.0D0
      QAM=A-1.0D0
      BZ=1.0D0-QAB*X/QAP
      DO 10 M=1,ITMAX
      ITREAL=M
      EM=M
      TEM=EM+EM
      D=EM*(B-M)*X/((QAM+TEM)*(A+TEM))
      AP=AZ+D*AM
      BP=BZ+D*BM
      D=-(A+EM)*(QAB+EM)*X/((A+TEM)*(QAP+TEM))
      APP=AP+D*AZ
      BPP=BP+D*BZ
      AOLD=AZ
      AM=AP/BPP
      BM=BP/BPP
      AZ=APP/BPP
      BZ=1.0D0
      IF(DABS(AZ-AOLD).LT.EPS*DABS(AZ)) GO TO 20
   10 CONTINUE
      IERR=67
   20 SFG6D1=AZ
      RETURN
      END
